<template>
  <q-page class="flex column">
    <!-- Toolbar -->
    <q-toolbar class="bg-background-primary">
      <div class="q-gutter-x-md">
        <q-btn label="Generate Template" color="secondary" @click="generateTemplate" />
      </div>

      <q-space />

      <div class="q-gutter-x-md">
        <q-toggle
          v-model="state.showTemplate"
          label="Show Template"
        />
        <q-btn label="Help" @click="app.showHelp(DocsGenerate)" color="accent" />
      </div>
    </q-toolbar>

    <q-toolbar v-if="template.error" class="bg-negative">
      {{ template.error }}
    </q-toolbar>

    <div class="flex row col-grow">
      <!-- Editor -->
      <div class="flex col">
        <div class="col">
          <div class="monaco-container">
            <vue-monaco-editor
              v-model:value="template.options"
              theme="vs-dark"
              :options="MONACO_EDITOR_OPTIONS"
              language="json"
              className="monaco"
            />
          </div>
        </div>
      </div>

      <!-- Artifact -->
      <div v-if="state.showTemplate" class="flex col">
        <div class="flex column col-grow">
          <div class="col col-shrink">
            <q-toolbar class="bg-background-primary">
              <q-btn color="secondary" label="Sign Template" @click="signTemplate" />
            </q-toolbar>
          </div>
          <div class="col col-grow">
            <div class="monaco-container">
              <vue-monaco-editor
                :value="generatedTemplateJson"
                theme="vs-dark"
                :options="MONACO_EDITOR_READONLY_OPTIONS"
                language="json"
                className="monaco"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </q-page>
</template>

<script setup lang="ts">
import { onBeforeUnmount, computed, ref } from 'vue';
import { useQuasar } from 'quasar';

import { app } from '../boot/app.js';

import { ArtifactsToAuthTemplate } from '../utils/artifact-to-auth-template.js';

import DocsGenerate from '../docs/generate.md?raw';

import GenerateSignTemplate from '../templates/generate_sign_template.html?raw';

import type { Artifact } from 'cashscript';
import JSON5 from 'json5'
import { merge } from 'lodash';

const $q = useQuasar();

//-----------------------------------------------------------------------------
// State
//-----------------------------------------------------------------------------

const MONACO_EDITOR_OPTIONS = {
  automaticLayout: true,
  formatOnType: true,
  formatOnPaste: true,
  language: 'javascript'
}

const MONACO_EDITOR_READONLY_OPTIONS = {
  ...MONACO_EDITOR_OPTIONS,
  readOnly: true,
}

const state = ref<{
  showTemplate: boolean,
}>({
  showTemplate: false,
});

const template = computed(() => app.project.value.template);
const generatedTemplateJson = computed(() => JSON.stringify(app.project.value.template.template, null, 2));

//-----------------------------------------------------------------------------
// Methods
//-----------------------------------------------------------------------------

async function generateTemplate() {
  try {
    // Get the stringified version of the previous template (so we can check if it changed).
    const oldTemplateStringified = JSON.stringify(template.value.template);

    // Reset the state.
    state.value.showTemplate = false;
    template.value.template = undefined;
    template.value.error = undefined;

    // Attempt to compile our contracts.
    app.compileContracts();

    // Extract all of our artifacts from our compiled templates.
    const artifacts = app.project.value.contracts.map((contract) => contract.artifact) as Array<Artifact>;

    // Conver the options to a JSON object and append our project name and description.
    const options = {
      ...JSON5.parse(template.value.options),
      name: app.project.value.name,
      description: app.project.value.description,
    }

    // Attempt to generate the Auth Template.
    const generatedTemplate = new ArtifactsToAuthTemplate(
      artifacts,
      options,
    ).build();

    const parsedOptions = JSON5.parse(template.value.options);

    const mergedTemplate = merge(generatedTemplate, parsedOptions);

    const newTemplateStringified = JSON.stringify(mergedTemplate);

    if(newTemplateStringified !== oldTemplateStringified) {
      // Disconnect Wallet Connect session.
      app.walletConnect.disconnect();

      // Notify user.
      $q.notify({ type: 'warning', message: 'Template has changed! You will need to reconnect your WalletConnect session.' });
    }

    // Set the compiled template.
    template.value.template = mergedTemplate;

    // Show the template.
    state.value.showTemplate = true;
  } catch(error: any) {
    // Log the error to the console.
    console.error(error);

    // Set the error against our project.
    app.project.value.template.error = error.message;

    // Do not display the template.
    state.value.showTemplate = false;

    // Show the user a notification.
    $q.notify({
      type: 'negative',
      message: error.message
    })
  }
}

function signTemplate() {
  $q.dialog({
    title: 'Sign Template',
    message: GenerateSignTemplate,
    html: true,
    class: 'help-dialog'
  })
}

//-----------------------------------------------------------------------------
// Initialization/Lifecycle
//-----------------------------------------------------------------------------

onBeforeUnmount(() => {
  generateTemplate();
});

if(app.project.value.template.template) {
  state.value.showTemplate = true;
}

</script>
